class ResourcePicturesController < ApplicationController
  before_filter :authenticate_user!, :only => [:index, :show]
  before_filter :authenticate_admin!, :only => [:list, :browse]

  # GET /resource_pictures
  # GET /resource_pictures.json
  def index
    @resource_pictures = ResourcePicture.find(:all, 
      :include => {:original_picture => [:artist, :license]}, :order => 'updated_at', :limit => 20
    )

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @resource_pictures.to_json(
        :include => [:original_picture, :artist, :license]
      ) }
    end
  end

  # GET /resource_pictures/1
  # GET /resource_pictures/1.json
  def show
    @resource_picture = ResourcePicture.find(params[:id])

    respond_to do |format|
      opt = {:type => @resource_picture.mime_type, :disposition=>"inline"}
      format.png { send_data(@resource_picture.restore(params[:subdir]), opt ) }
      format.gif { send_data(@resource_picture.restore(params[:subdir]), opt ) }
      format.jpeg { send_data(@resource_picture.restore(params[:subdir]), opt ) }
      format.html # show.html.erb
      format.json { render json: @resource_picture}
    end
  end

  def list
    @resource_pictures = ResourcePicture.all

    respond_to do |format|
      format.html { render layout: 'system' }
      format.json { render json: @resource_pictures }
    end
  end

  def browse
    @resource_picture = ResourcePicture.find(params[:id])

    respond_to do |format|
      format.html { render layout: 'system' }
      format.json { render json: @resource_picture }
    end
  end

end
