require 'picture_io'
require 'aws/s3'
class PictureIO
  class S3Picture
    def initialize base_dir = 'pettanr'
      @base = base_dir
    end
    
    def base
      @base
    end
    
    def base=(b)
      @base = b
    end
    
    def self.subdirs
      ['', 'v', 'h', 'vh', 'thumbnail']
    end
    
    def dir(subdir = nil)
      sd = if subdir.to_s.empty?
        ''
      else
        subdir.to_s + '/'
      end
      sd
    end
    
    def exist?(filename, subdir = nil)
      AWS::S3::S3Object.exist?(dir(subdir) + filename)
    end
    
    def put(bindata, filename, subdir = nil)
      AWS::S3::S3Object.store(dir(subdir) + filename, bindata, base)
    end
    
    def get(filename, subdir = nil)
      bindata = ''
  #      if AWS::S3::S3Object.exists?(fn, 'pettanr')
      AWS::S3::S3Object.stream(dir(subdir) + filename, base) do |st|
        bindata += st if st
      end
      bindata
    end
    
    def delete(filename, subdir = nil)
      AWS::S3::S3Object.delete(dir(subdir) + filename, base)
    end
    
  end
end
