require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe OriginalPicturesController do

  # This should return the minimal set of attributes required to create a valid
  # OriginalPicture. As you add validations to OriginalPicture, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all original_pictures as @original_pictures" do
      original_picture = OriginalPicture.create! valid_attributes
      get :index
      assigns(:original_pictures).should eq([original_picture])
    end
  end

  describe "GET show" do
    it "assigns the requested original_picture as @original_picture" do
      original_picture = OriginalPicture.create! valid_attributes
      get :show, :id => original_picture.id
      assigns(:original_picture).should eq(original_picture)
    end
  end

  describe "GET new" do
    it "assigns a new original_picture as @original_picture" do
      get :new
      assigns(:original_picture).should be_a_new(OriginalPicture)
    end
  end

  describe "GET edit" do
    it "assigns the requested original_picture as @original_picture" do
      original_picture = OriginalPicture.create! valid_attributes
      get :edit, :id => original_picture.id
      assigns(:original_picture).should eq(original_picture)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new OriginalPicture" do
        expect {
          post :create, :original_picture => valid_attributes
        }.to change(OriginalPicture, :count).by(1)
      end

      it "assigns a newly created original_picture as @original_picture" do
        post :create, :original_picture => valid_attributes
        assigns(:original_picture).should be_a(OriginalPicture)
        assigns(:original_picture).should be_persisted
      end

      it "redirects to the created original_picture" do
        post :create, :original_picture => valid_attributes
        response.should redirect_to(OriginalPicture.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved original_picture as @original_picture" do
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalPicture.any_instance.stub(:save).and_return(false)
        post :create, :original_picture => {}
        assigns(:original_picture).should be_a_new(OriginalPicture)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalPicture.any_instance.stub(:save).and_return(false)
        post :create, :original_picture => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested original_picture" do
        original_picture = OriginalPicture.create! valid_attributes
        # Assuming there are no other original_pictures in the database, this
        # specifies that the OriginalPicture created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        OriginalPicture.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => original_picture.id, :original_picture => {'these' => 'params'}
      end

      it "assigns the requested original_picture as @original_picture" do
        original_picture = OriginalPicture.create! valid_attributes
        put :update, :id => original_picture.id, :original_picture => valid_attributes
        assigns(:original_picture).should eq(original_picture)
      end

      it "redirects to the original_picture" do
        original_picture = OriginalPicture.create! valid_attributes
        put :update, :id => original_picture.id, :original_picture => valid_attributes
        response.should redirect_to(original_picture)
      end
    end

    describe "with invalid params" do
      it "assigns the original_picture as @original_picture" do
        original_picture = OriginalPicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalPicture.any_instance.stub(:save).and_return(false)
        put :update, :id => original_picture.id, :original_picture => {}
        assigns(:original_picture).should eq(original_picture)
      end

      it "re-renders the 'edit' template" do
        original_picture = OriginalPicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalPicture.any_instance.stub(:save).and_return(false)
        put :update, :id => original_picture.id, :original_picture => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested original_picture" do
      original_picture = OriginalPicture.create! valid_attributes
      expect {
        delete :destroy, :id => original_picture.id
      }.to change(OriginalPicture, :count).by(-1)
    end

    it "redirects to the original_pictures list" do
      original_picture = OriginalPicture.create! valid_attributes
      delete :destroy, :id => original_picture.id
      response.should redirect_to(original_pictures_url)
    end
  end

end
